package ex_checkboxValidator
{
	import mx.validators.ValidationResult;
	import mx.validators.Validator;
	
	import spark.components.CheckBox;
	import spark.components.Group;
	
	public class CheckboxValidator extends Validator
	{

		public var minChecked:uint;
		public var maxChecked:uint;
		
		public function CheckboxValidator()
		{
			super();
		}
		
		override protected function doValidation(value:Object):Array
		{
			// Initialise le tableau de résultats
			var results:Array = results = [];
			var count:uint = 0;
			
			// Vérifie chaque checkbox du groupe
			var group:Group = value as Group;
			for (var i:uint = 0; i<group.numChildren; i++)
			{
				var child:CheckBox = group.getChildAt(i) as CheckBox;
				if (child != null)
				{
					if (child.selected)
						count++;
				}
			}
			
			// Ajout d'une erreur de validation
			if (count<minChecked || count>maxChecked)
			{
				var err:ValidationResult = new ValidationResult(true, "", "", "Cochez entre "+minChecked+" et "+maxChecked+" choix");
				results.push(err);
				setColor(value as Group, "#FF0000");
			}
			else
				setColor(value as Group, "#000000");
			
			return results;
		}
		
		// Modifie la couleur de chaque checkbox du groupe
		private function setColor(group:Group, color:String):void
		{
			for (var i:uint = 0; i<group.numChildren; i++)
			{
				var child:CheckBox = group.getChildAt(i) as CheckBox;
				child.setStyle("color", color);
			}
		}
	}
}